Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version: Candidate for next minor release   

Resolution:  Affected version: 3.2.3

Description

When formatting a table in markdown, and inserting internal wiki links via [[wiki_page_name|custom name]], such as:

| header | [[FAQ]] | [[Plugins|List of Plugins]] |

|--------|---------|-----------------------------|

| aaa    | bbb     | ccc                         |

 The [[Plugins|List of Plugins]] will get incorrectly truncated at | which is interpreted as signaling the end of that column, and hence the

URL link is not generated as it breaks off before reaching the ]].

Related issues:

Related to Redmine - Defect #29852: Cannot use Wiki link with a different nam... Closed

History

#1 - 2016-07-14 18:29 - Ben Blanco

FWIW, in the meantime, the following workaround is available:

Instead of [[wiki_page_name|custom name]] one can write [custom name](wiki_page_name).

Updating the above table example:

| header | [[FAQ]] | [List of Plugins](Plugins) |

|--------|---------|----------------------------|

| aaa    | bbb     | ccc                        |

 Disclaimer: I don't know if this workaround would work for cross-project-wiki references...

#2 - 2017-10-11 17:18 - Ben Blanco

- File redmine_3.4.2.png added

FYI - This problem remains in latest redmine v3.4.2 (and its updated redcarpet gem)

In redmine 3.3.x and 3.4.x, it renders as such:

 redmine_3.4.2.png 

Could this problem be due to redcarpet gem itself, vs. redmine's integration of redcarpet..?

#3 - 2018-10-27 03:17 - Go MAEDA

- Related to Defect #29852: Cannot use Wiki link with a different name in the table of markdown added

#4 - 2018-11-14 14:20 - Takenori TAKAKI

- File 23341.patch added

I confirmed that redcarpet gem cannot distinguish '|'.

To solve this problem, It is necessary to replace '|', before and after redcarpet is formatting Markdown to HTML.

So, I made a patch that overrides Redcarpet::Render::HTML#preprocess and #postprocess methods and replace '|'.

#5 - 2018-12-01 09:13 - Go MAEDA

- Target version set to Candidate for next minor release
#6 - 2019-08-01 16:13 - Martin Cizek

- File 23341-fixed-regexp.patch added

Thanks Takenori for the patch. I've found out that the regexp does not work when it is trying to replace the &#124; placeholder back with |, as the

placeholder is multicharacter and used in a character class.

As a result, it does not work if the name contains e.g. numbers 1, 2 or 4.

The solution is to use this regexp:

          full_document.gsub(/(\[\[(((?![\]\n]|#{pattern}).)+)(#{pattern})(((?![\]\n]|#{pattern}).)+)\]\])/) d

o |m|

            all, page, separater, title = $1, $2, $4, $5

 A new patch is attached (it's against Redmine 3.4 though).
